<?php

namespace DC\LinkProxy\XF\BbCode\Renderer;

class Html extends \XF\BbCode\Renderer\Html
{
    protected function getRenderedLink($text, $url, array $options)
	{
		$linkInfo = $this->formatter->getLinkClassTarget($url);
		$rels = [];

		$classAttr = $linkInfo['class'] ? " class=\"$linkInfo[class]\"" : '';
		$targetAttr = $linkInfo['target'] ? " target=\"$linkInfo[target]\"" : '';

		if (!$linkInfo['trusted'] && !empty($options['noFollowUrl']))
		{
			$rels[] = 'nofollow';
		}

		if ($linkInfo['target'])
		{
			$rels[] = 'noopener';
		}

		$proxyAttr = '';
		if (empty($options['noProxy']))
		{
			$proxyUrl = $this->formatter->getProxiedUrlIfActive('link', $url);
			if ($proxyUrl)
			{
				$proxyAttr = ' data-proxy-href="' . htmlspecialchars($proxyUrl) . '"';
			}
		}

		if ($rels)
		{
			$relAttr = ' rel="' . implode(' ', $rels) . '"';
		}
		else
		{
			$relAttr = '';
        }
        
        $link = $this->formatter->getLinkClassTarget($url);

        if ($link['type'] != 'internal')
        {
			$baseUrl = (isset($_SERVER['HTTPS']) ? "https" : "http") . "://$_SERVER[HTTP_HOST]";
			$options = \XF::options();
			
			/** Check white listed domains */
			$domainWhiteListed = $options->DC_LinkProxy_DomainWhiteList;
			$domainWhiteListedArray = explode("\n", $domainWhiteListed);
			$domain = parse_url($url, PHP_URL_HOST);

			$urlEnconded = $baseUrl . '/redirect?to=' . base64_encode(htmlspecialchars($url));

			foreach ($domainWhiteListedArray as &$value) {
				if ( $domain == $value )
				{
					$urlEnconded = $url;
				}
			}

			/** $urlEnconded = $baseUrl . '/redirect?to=' . base64_encode(htmlspecialchars($url)); */
        } else {
            $urlEnconded = htmlspecialchars($url);
        }

		return $this->wrapHtml(
			'<a href="' . $urlEnconded . '"' . $targetAttr . $classAttr . $proxyAttr . $relAttr . '>',
			$text,
			'</a>'
		);
	}
}